unit UnitZumenColor;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls,
  UnitData,  UnitFunc ;

type
  TFmZumenColor = class(TForm)
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Edit1: TEdit;
    Edit2: TEdit;
    Edit3: TEdit;
    Button1: TButton;
    ListBox1: TListBox;
    Button2: TButton;
    Button3: TButton;
    ColorDialog1: TColorDialog;
    Label1: TLabel;
    procedure FormShow(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Button1Click(Sender: TObject);
    procedure ListBox1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Edit1Change(Sender: TObject);
  private
    { Private 錾 }
  public
    { Public 錾 }
    P_CData : TDataClass ;
  end;

var
  FmZumenColor: TFmZumenColor;

implementation

{$R *.dfm}

// N
procedure TFmZumenColor.FormShow(Sender: TObject);
var
   i : integer ;
   s : string ;
begin
   ListBox1.Items.Clear ;
   for i:=0 to P_CData.zColN-1 do begin
      s := IntToStr(P_CData.zCol[i].Red) + ','
         + IntToStr(P_CData.zCol[i].Green) + ','
         + IntToStr(P_CData.zCol[i].Blue) ;
      ListBox1.Items.Add(s);
   end;
end;

// I
procedure TFmZumenColor.FormClose(Sender: TObject; var Action: TCloseAction);
begin
   //
end;

// [ǉo^]
procedure TFmZumenColor.Button1Click(Sender: TObject);
var
   r : Boolean ;
   i : integer ;
   s : string ;
begin
   r := P_CData.AddColor(SInt(Edit1.Text),SInt(Edit2.Text),SInt(Edit3.Text));
   if (r) then begin
      ListBox1.Items.Clear ;
      for i:=0 to P_CData.zColN-1 do begin
         s := IntToStr(P_CData.zCol[i].Red) + ','
            + IntToStr(P_CData.zCol[i].Green) + ','
            + IntToStr(P_CData.zCol[i].Blue) ;
         ListBox1.Items.Add(s);
      end;
   end
   else
      ShowMessage('Fǉo^o܂ł');
end;

// FꗗNbNlmF
procedure TFmZumenColor.ListBox1Click(Sender: TObject);
var
   i : integer ;
begin
   if (ListBox1.Items.Count = 0) then exit;
   i := ListBox1.ItemIndex;
   if (i = -1) then exit;
   if (i >= P_CData.zColN) then exit;
   with P_CData.zCol[i] do begin
      Edit1.Text := IntToStr(Red);
      Edit2.Text := IntToStr(Green);
      Edit3.Text := IntToStr(Blue);
   end;
end;

// []
procedure TFmZumenColor.Button2Click(Sender: TObject);
begin
   close ;
end;

// [FI]
procedure TFmZumenColor.Button3Click(Sender: TObject);
var
   r,g,b,c : integer ;
begin
   r := SInt(Edit1.Text);
   g := SInt(Edit2.Text);
   b := SInt(Edit3.Text);
   if (r < 0) then r := 0 else if (r > 255) then r := 255;
   if (g < 0) then g := 0 else if (g > 255) then g := 255;
   if (b < 0) then b := 0 else if (b > 255) then b := 255;
   c := RGB(r,g,b);
   ColorDialog1.Color := c;
   if (ColorDialog1.Execute) then begin
      c := ColorDialog1.Color ;
      r := c mod 256;
      g := c div 256 mod 256;
      b := c div 65536;
      Edit1.Text := IntToStr(r);
      Edit2.Text := IntToStr(g);
      Edit3.Text := IntToStr(b);
   end;
end;

// l͂ɉʍ̃x̐Fς
procedure TFmZumenColor.Edit1Change(Sender: TObject);
var
   r,g,b : integer ;
begin
   r := SInt(Edit1.Text);
   g := SInt(Edit2.Text);
   b := SInt(Edit3.Text);
   if (r < 0) then r := 0 else if (r > 255) then r := 255;
   if (g < 0) then g := 0 else if (g > 255) then g := 255;
   if (b < 0) then b := 0 else if (b > 255) then b := 255;
   Label1.Color := RGB(r,g,b);
end;

end.
